Index: uspace/lib/fs/libfs.c
===================================================================
--- uspace/lib/fs/libfs.c	(revision ad67aa19e11627f827359611184995fde5f43850)
+++ uspace/lib/fs/libfs.c	(revision 61042de30507a8c30110c0dfce737a78456207d3)
@@ -79,5 +79,6 @@
 static void libfs_open_node(libfs_ops_t *, fs_handle_t, ipc_callid_t,
     ipc_call_t *);
-static void libfs_statfs(libfs_ops_t *, fs_handle_t, ipc_callid_t, ipc_call_t *);
+static void libfs_statfs(libfs_ops_t *, fs_handle_t, ipc_callid_t,
+    ipc_call_t *);
 
 static void vfs_out_mounted(ipc_callid_t rid, ipc_call_t *req)
@@ -157,7 +158,8 @@
 	rc = vfs_out_ops->write(service_id, index, pos, &wbytes, &nsize);
 
-	if (rc == EOK)
-		async_answer_3(rid, EOK, wbytes, LOWER32(nsize), UPPER32(nsize));
-	else
+	if (rc == EOK) {
+		async_answer_3(rid, EOK, wbytes, LOWER32(nsize),
+		    UPPER32(nsize));
+	} else
 		async_answer_0(rid, rc);
 }
@@ -198,7 +200,6 @@
 		bool destroy = (libfs_ops->lnkcnt_get(node) == 0);
 		libfs_ops->node_put(node);
-		if (destroy) {
+		if (destroy)
 			rc = vfs_out_ops->destroy(service_id, index);
-		}
 	}
 	async_answer_0(rid, rc);
@@ -239,10 +240,8 @@
 	fs_node_t *node = NULL;
 	rc = libfs_ops->node_get(&node, service_id, index);
-	if (rc != EOK) {
+	if (rc != EOK)
 		async_answer_0(rid, rc);
-	}
-	if (node == NULL) {
+	if (node == NULL)
 		async_answer_0(rid, EINVAL);
-	}
 	
 	uint64_t size = libfs_ops->size_get(node);
@@ -260,10 +259,8 @@
 	fs_node_t *node = NULL;
 	rc = libfs_ops->node_get(&node, service_id, index);
-	if (rc != EOK) {
+	if (rc != EOK)
 		async_answer_0(rid, rc);
-	}
-	if (node == NULL) {
+	if (node == NULL)
 		async_answer_0(rid, EINVAL);
-	}
 	
 	bool children = false;
@@ -271,7 +268,6 @@
 	libfs_ops->node_put(node);
 	
-	if (rc != EOK) {
+	if (rc != EOK)
 		async_answer_0(rid, rc);
-	}
 	async_answer_0(rid, children ? ENOTEMPTY : EOK);
 }
@@ -445,5 +441,6 @@
 }
 
-static int plb_get_component(char *dest, unsigned *sz, unsigned *ppos, unsigned last)
+static int plb_get_component(char *dest, unsigned *sz, unsigned *ppos,
+    unsigned last)
 {
 	unsigned pos = *ppos;
@@ -456,7 +453,6 @@
 
 	char c = plb_get_char(pos); 
-	if (c == '/') {
+	if (c == '/')
 		pos++;
-	}
 	
 	for (int i = 0; i <= NAME_MAX; i++) {
@@ -480,7 +476,6 @@
 	ipc_callid_t wcall;
 	
-	if (!async_data_write_receive(&wcall, &size)) {
+	if (!async_data_write_receive(&wcall, &size))
 		return ENOENT;
-	}
 	if (size > NAME_MAX + 1) {
 		async_answer_0(wcall, ERANGE);
@@ -492,5 +487,6 @@
 /** Link a file at a path.
  */
-void libfs_link(libfs_ops_t *ops, fs_handle_t fs_handle, ipc_callid_t rid, ipc_call_t *req)
+void libfs_link(libfs_ops_t *ops, fs_handle_t fs_handle, ipc_callid_t rid,
+    ipc_call_t *req)
 {
 	service_id_t parent_sid = IPC_GET_ARG1(*req);
@@ -658,7 +654,6 @@
 			int64_t size = ops->size_get(cur);
 			int32_t lsize = LOWER32(size);
-			if (lsize != size) {
+			if (lsize != size)
 				lsize = -1;
-			}
 			
 			async_answer_5(rid, fs_handle, service_id,
@@ -680,5 +675,6 @@
 	
 		if (!cur) {
-			rc = ops->create(&cur, service_id, lflag & (L_FILE|L_DIRECTORY));
+			rc = ops->create(&cur, service_id,
+			    lflag & (L_FILE | L_DIRECTORY));
 			if (rc != EOK) {
 				async_answer_0(rid, rc);
@@ -703,6 +699,6 @@
 out1:
 	if (!cur) {
-		async_answer_5(rid, fs_handle, service_id,
-		    ops->index_get(par), last_next, -1, true);
+		async_answer_5(rid, fs_handle, service_id, ops->index_get(par),
+		    last_next, -1, true);
 		goto out;
 	}
@@ -718,7 +714,6 @@
 	int64_t size = ops->size_get(cur);
 	int32_t lsize = LOWER32(size);
-	if (lsize != size) {
+	if (lsize != size)
 		lsize = -1;
-	}
 	
 	async_answer_5(rid, fs_handle, service_id, ops->index_get(cur), last,
@@ -726,15 +721,12 @@
 	
 out:
-	if (par) {
+	if (par)
 		(void) ops->node_put(par);
-	}
-	
-	if (cur) {
+	
+	if (cur)
 		(void) ops->node_put(cur);
-	}
-	
-	if (tmp) {
+	
+	if (tmp)
 		(void) ops->node_put(tmp);
-	}
 }
 
@@ -857,5 +849,6 @@
 	async_answer_4(rid, rc, LOWER32(size), UPPER32(size),
 	    ops->lnkcnt_get(fn),
-	    (ops->is_file(fn) ? L_FILE : 0) | (ops->is_directory(fn) ? L_DIRECTORY : 0));
+	    (ops->is_file(fn) ? L_FILE : 0) |
+	    (ops->is_directory(fn) ? L_DIRECTORY : 0));
 	
 	(void) ops->node_put(fn);