Index: uspace/lib/c/generic/devman.c
===================================================================
--- uspace/lib/c/generic/devman.c	(revision 9a99aa590ef49523397169b86b44756008e1d749)
+++ uspace/lib/c/generic/devman.c	(revision 78188e5873f47aad1ea0bb8b9e68b6f694b89dc4)
@@ -45,5 +45,4 @@
 #include <errno.h>
 #include <malloc.h>
-#include <stdbool.h>
 
 static FIBRIL_MUTEX_INITIALIZE(devman_driver_block_mutex);
Index: uspace/lib/c/include/adt/hash.h
===================================================================
--- uspace/lib/c/include/adt/hash.h	(revision 9a99aa590ef49523397169b86b44756008e1d749)
+++ uspace/lib/c/include/adt/hash.h	(revision 78188e5873f47aad1ea0bb8b9e68b6f694b89dc4)
@@ -36,4 +36,5 @@
 
 #include <stdint.h>
+#include <sys/types.h>
 
 /** Produces a uniform hash affecting all output bits from the skewed input. */
Index: uspace/lib/c/include/atomicdflt.h
===================================================================
--- uspace/lib/c/include/atomicdflt.h	(revision 9a99aa590ef49523397169b86b44756008e1d749)
+++ uspace/lib/c/include/atomicdflt.h	(revision 78188e5873f47aad1ea0bb8b9e68b6f694b89dc4)
@@ -40,5 +40,5 @@
 #endif
 
-#include <stdint.h>
+#include <libarch/types.h>
 #include <stdbool.h>
 
Index: uspace/lib/c/include/fibril.h
===================================================================
--- uspace/lib/c/include/fibril.h	(revision 9a99aa590ef49523397169b86b44756008e1d749)
+++ uspace/lib/c/include/fibril.h	(revision 78188e5873f47aad1ea0bb8b9e68b6f694b89dc4)
@@ -37,4 +37,5 @@
 
 #include <libarch/fibril.h>
+#include <libarch/types.h>
 #include <adt/list.h>
 #include <libarch/tls.h>
Index: uspace/lib/c/include/inet/dhcp.h
===================================================================
--- uspace/lib/c/include/inet/dhcp.h	(revision 9a99aa590ef49523397169b86b44756008e1d749)
+++ uspace/lib/c/include/inet/dhcp.h	(revision 78188e5873f47aad1ea0bb8b9e68b6f694b89dc4)
@@ -36,4 +36,5 @@
 #define LIBC_INET_DHCP_H_
 
+#include <libarch/types.h>
 
 extern int dhcp_init(void);
Index: uspace/lib/c/include/io/chargrid.h
===================================================================
--- uspace/lib/c/include/io/chargrid.h	(revision 9a99aa590ef49523397169b86b44756008e1d749)
+++ uspace/lib/c/include/io/chargrid.h	(revision 78188e5873f47aad1ea0bb8b9e68b6f694b89dc4)
@@ -37,6 +37,7 @@
 #define LIBC_IO_CHARGRID_H_
 
+#include <io/charfield.h>
+#include <libarch/types.h>
 #include <stddef.h>
-#include <io/charfield.h>
 
 typedef enum {
Index: uspace/lib/c/include/io/pixelmap.h
===================================================================
--- uspace/lib/c/include/io/pixelmap.h	(revision 9a99aa590ef49523397169b86b44756008e1d749)
+++ uspace/lib/c/include/io/pixelmap.h	(revision 78188e5873f47aad1ea0bb8b9e68b6f694b89dc4)
@@ -38,4 +38,6 @@
 #define LIBC_IO_PIXELMAP_H_
 
+#include <libarch/types.h>
+#include <stdbool.h>
 #include <stddef.h>
 #include <io/pixel.h>
Index: uspace/lib/c/include/io/pos_event.h
===================================================================
--- uspace/lib/c/include/io/pos_event.h	(revision 9a99aa590ef49523397169b86b44756008e1d749)
+++ uspace/lib/c/include/io/pos_event.h	(revision 78188e5873f47aad1ea0bb8b9e68b6f694b89dc4)
@@ -37,4 +37,5 @@
 #define LIBC_IO_POS_EVENT_H_
 
+#include <libarch/types.h>
 
 typedef enum {
Index: uspace/lib/c/include/stdbool.h
===================================================================
--- uspace/lib/c/include/stdbool.h	(revision 9a99aa590ef49523397169b86b44756008e1d749)
+++ uspace/lib/c/include/stdbool.h	(revision 78188e5873f47aad1ea0bb8b9e68b6f694b89dc4)
@@ -36,5 +36,4 @@
 #define LIBC_BOOL_H_
 
-#include <libarch/types.h>
 #include <abi/bool.h>
 
Index: uspace/lib/c/include/sysinfo.h
===================================================================
--- uspace/lib/c/include/sysinfo.h	(revision 9a99aa590ef49523397169b86b44756008e1d749)
+++ uspace/lib/c/include/sysinfo.h	(revision 78188e5873f47aad1ea0bb8b9e68b6f694b89dc4)
@@ -36,4 +36,5 @@
 #define LIBC_SYSINFO_H_
 
+#include <libarch/types.h>
 #include <stddef.h>
 #include <stdbool.h>