Index: uspace/lib/libc/Makefile
===================================================================
--- uspace/lib/libc/Makefile	(revision 49b2dc3f313c3a625586656554c2fc5f4512df21)
+++ uspace/lib/libc/Makefile	(revision 80791a7214b411e1af8266d1f280249f724a3652)
@@ -58,4 +58,5 @@
 	generic/task.c \
 	generic/futex.c \
+	generic/io/asprintf.c \
 	generic/io/io.c \
 	generic/io/printf.c \
Index: uspace/lib/libc/generic/io/asprintf.c
===================================================================
--- uspace/lib/libc/generic/io/asprintf.c	(revision 80791a7214b411e1af8266d1f280249f724a3652)
+++ uspace/lib/libc/generic/io/asprintf.c	(revision 80791a7214b411e1af8266d1f280249f724a3652)
@@ -0,0 +1,71 @@
+/*
+ * Copyright (c) 2006 Josef Cejka
+ * Copyright (c) 2008 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+/** @file
+ */
+
+#include <stdarg.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <io/printf_core.h>
+
+static int asprintf_prewrite(const char *str, size_t count, void *unused)
+{
+	return count;
+}
+
+int asprintf(char **strp, const char *fmt, ...)
+{
+	struct printf_spec ps = {
+		 asprintf_prewrite,
+		 NULL
+	};
+	int ret;
+	va_list args;
+
+	va_start(args, fmt);
+	ret = printf_core(fmt, &ps, args);
+	va_end(args);
+	if (ret > 0) {
+		*strp = malloc(ret + 20);
+		if (!*strp)
+			return -1;
+		va_start(args, fmt);
+		vsprintf(*strp, fmt, args);
+		va_end(args);		
+	}
+
+	return ret;
+}
+
+/** @}
+ */
Index: uspace/lib/libc/generic/io/sprintf.c
===================================================================
--- uspace/lib/libc/generic/io/sprintf.c	(revision 49b2dc3f313c3a625586656554c2fc5f4512df21)
+++ uspace/lib/libc/generic/io/sprintf.c	(revision 80791a7214b411e1af8266d1f280249f724a3652)
@@ -49,5 +49,4 @@
 	va_start(args, fmt);
 	ret = vsprintf(str, fmt, args);
-
 	va_end(args);
 
Index: uspace/lib/libc/include/stdio.h
===================================================================
--- uspace/lib/libc/include/stdio.h	(revision 49b2dc3f313c3a625586656554c2fc5f4512df21)
+++ uspace/lib/libc/include/stdio.h	(revision 80791a7214b411e1af8266d1f280249f724a3652)
@@ -55,14 +55,15 @@
 extern int getchar(void);
 
-extern int puts(const char * str);
-extern int putchar(int c);
+extern int puts(const char *);
+extern int putchar(int);
 
-extern int printf(const char *fmt, ...);
-extern int sprintf(char *str, const char *fmt, ...);
-extern int snprintf(char *str, size_t size, const char *fmt, ...);
+extern int printf(const char *, ...);
+extern int asprintf(char **, const char *, ...);
+extern int sprintf(char *, const char *fmt, ...);
+extern int snprintf(char *, size_t , const char *, ...);
 
-extern int vprintf(const char *fmt, va_list ap);
-extern int vsprintf(char *str, const char *fmt, va_list ap);
-extern int vsnprintf(char *str, size_t size, const char *fmt, va_list ap);
+extern int vprintf(const char *, va_list);
+extern int vsprintf(char *, const char *, va_list);
+extern int vsnprintf(char *, size_t, const char *, va_list);
 
 #define fprintf(f, fmt, ...) printf(fmt, ##__VA_ARGS__)